<script lang="ts">
import Vue from 'vue';
import GlobeGraphic from '../assets/globe-graphic.vue';
import ParallaxContainer from './parallax-container.vue';

export default Vue.extend({
  name: 'SurveyHero',
  components: {
    GlobeGraphic,
    ParallaxContainer,
  },
  props: {
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
  },
});
</script>

<template>
  <div class="survey-hero" :class="data.variant">
    <SlpContainer
      ><div
        v-if="data.graphic"
        class="survey-hero__animation"
        :class="{
          'survey-hero__animation--half-globe': data?.asset === 'half-globe',
          'survey-hero__animation--bottom': data?.position === 'bottom',
        }"
      >
        <component
          :is="data.graphic"
          variant="hero"
          :asset="data?.asset"
          :width="data?.width"
          :height="data?.height"
        />
      </div>

      <div
        v-if="data.background"
        class="survey-hero__background"
        data-aos="zoom-in-up"
        :data-aos-duration="data.aos_duration"
        :data-aos-offset="data.aos_offset"
      ></div>
      <SlpRow class="survey-hero__text-content">
        <SlpColumn
          class="survey-hero__content"
          :class="{ 'survey-hero__content--left-padding': data.left_padding }"
        >
          <div v-if="data.note?.text" class="survey-hero__wrapper">
            <SlpTypography
              :variant="data?.note.variant ? data.note.variant : 'heading5'"
              tag="p"
              class="survey-hero__note slp-mb-24 survey-hero__wrapper__content"
              :data-aos="data.aos_animation"
              :data-aos-duration="data.aos_duration"
              :data-aos-offset="data.aos_offset"
              >{{ data.note.text }}</SlpTypography
            >
          </div>
          <div v-if="data.title.text" class="survey-hero__wrapper">
            <SlpTypography
              variant="heading1-bold"
              tag="h1"
              class="survey-hero__wrapper__content slp-mb-24 survey-hero__title"
              :data-aos="data.aos_animation"
              :data-aos-duration="data.aos_duration"
              :data-aos-offset="data.aos_offset"
              >{{ data.title.text }}</SlpTypography
            >
          </div>
          <SlpRow>
            <SlpColumn :cols="data?.cols ? data?.cols : 10">
              <div v-if="data.description.text" class="survey-hero__wrapper">
                <SlpTypography
                  variant="heading5-bold"
                  tag="div"
                  class="survey-hero__wrapper__content slp-mb-24"
                  :data-aos="data.aos_animation"
                  :data-aos-duration="data.aos_duration"
                  :data-aos-offset="data.aos_offset"
                >
                  <div v-html="data.description.text"></div
                ></SlpTypography>
              </div>
              <div v-if="data.primary_btn?.text" class="survey-hero__wrapper">
                <SlpButton
                  variant="primary"
                  class="survey-hero__wrapper__content slp-mb-8 survey-hero__button"
                  :data-ga-name="
                    data.primary_btn.data_ga_name || 'read the full survey'
                  "
                  :data-ga-location="
                    data.primary_btn.data_ga_location || 'hero'
                  "
                  :href="data.primary_btn.url || '#download'"
                  :data-aos="data.aos_animation"
                  :data-aos-duration="data.aos_duration"
                  :data-aos-offset="data.aos_offset"
                  >{{ data.primary_btn.text }}
                  <SlpIcon
                    v-if="data.primary_btn.icon"
                    :name="data.primary_btn.icon.name"
                    :variant="data.primary_btn.icon.variant"
                    class="slp-ml-8"
                  />
                </SlpButton>
              </div>
            </SlpColumn>
          </SlpRow>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
.survey-hero {
  color: $color-primary-300;
  position: relative;
  mix-blend-mode: lighten;
  padding: 0;
  min-height: 500px;
  @media (min-width: $breakpoint-md) {
    &.survey-tabs__section {
      margin: 96px 0 160px;
    }
  }
  &__animation {
    position: absolute;
    top: 0%;
    width: 100%;
    max-width: 540px;
    @media (min-width: $breakpoint-md) {
      top: -15%;
    }
    &--half-globe {
      @media (min-width: $breakpoint-md) {
        top: -100px;
        right: 120px;
      }
    }
    &--bottom {
      @media (min-width: $breakpoint-md) {
        transform: rotate(29deg);
        left: 0;
        top: -173px;
      }
    }
  }
  &__note {
    font-family: 'GitLab Mono', sans-serif;
    color: #5dd7b1;
  }
  &__wrapper {
    overflow-y: hidden;
    overflow-y: clip;
    max-width: 800px;
    z-index: 1;
  }
  &__background {
    position: absolute;
    top: -35%;
    left: 29%;
    @media (min-width: $breakpoint-md) {
      top: -95%;
    }
  }
  &__content {
    margin-left: 0;
    &--left-padding {
      @media (min-width: $breakpoint-md) {
        margin-left: $spacing-96;
      }
    }
  }
  &__button {
    position: relative;
    transition: 0.4s ease;
    z-index: 1;
    border-radius: 5px;
    border: 1px solid #5dd7b1;
    background: transparent;
    position: relative;
    &:hover,
    &:active {
      background-color: #5dd7b1;
    }
  }
  &__text-content {
    z-index: 1;
    position: relative;
  }
  :deep a:not(.slp-btn) {
    text-decoration: underline;
    color: #5dd7b1;
  }
}
</style>
